//+------------------------------------------------------------------+
//|                                TrendEnvelopes_v6_STF_4TF[B].mq4  | 
//| custom   TrendEnvelopes_v5.mq4                                   |                    
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "TrendEnvelopes_v6_STF_4TF[B]"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red//EMPTY
#property indicator_width1 1
#property indicator_color2 Lime//EMPTY
#property indicator_width2 1
#property indicator_color3 Red
#property indicator_width3 1
#property indicator_color4 Lime
#property indicator_width4 1
#property indicator_color5 Red
#property indicator_color6 Lime
#property indicator_color7 Red
#property indicator_width7 1
#property indicator_color8 GreenYellow
#property indicator_width8 1

#property indicator_maximum 4.9                    
#property indicator_minimum 0.4
//===================================================================================

extern int     MA_Per_1M      =  44;
extern int     MA_Per_5M      =  6; 
extern int     MA_Per_15M     =  6;
extern int     MA_Per_30M     =  6;
extern int     MA_Per_60M     =  6;

extern int     MA_SiEmSmWe3   =  2;//*************** now SMMA

//===================================================================================

extern int    DotSize_110_167 = 116 ; //167
extern int    ArrowSize       = 6 ;
extern int    CountBars       = 2000 ;

extern int    TFA  = 0 ;    
extern int    TFB  = 0 ;
extern int    TFC  = 0 ;
extern int    TFD  = 0 ;

bool   StepTFA_Up   =  true; 
bool   StepTFB_Up   =  true; 
bool   StepTFC_Up   =  true; 
bool   StepTFD_Up   =  true; 

double TEPAm_up  , TEPAm_dn ;
double TEPBm_up  , TEPBm_dn ;
double TEPCm_up  , TEPCm_dn ;
double TEPDm_up  , TEPDm_dn ;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,DotSize_110_167);  
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,DotSize_110_167);  
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,DotSize_110_167);  
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,DotSize_110_167);  
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,DotSize_110_167);  
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,DotSize_110_167);  
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
   
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,DotSize_110_167);  
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,DotSize_110_167);  
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexEmptyValue(7,0.0);

//========================================================================================
     switch(TFA)   {    case 1 : string TimeFrameStrA="Period_M1"; break;
                        case 5 : TimeFrameStrA="Period_M5"; break;
                       case 15 : TimeFrameStrA="Period_M15"; break;
                       case 30 : TimeFrameStrA="Period_M30"; break;
                       case 60 : TimeFrameStrA="Period_H1"; break;
                      case 240 : TimeFrameStrA="Period_H4"; break;
                     case 1440 : TimeFrameStrA="Period_D1"; break;
                    case 10080 : TimeFrameStrA="Period_W1"; break;
                    case 43200 : TimeFrameStrA="Period_MN1"; break;
                       default : TimeFrameStrA="Current Timeframe";
                   SetStepTFA_Up();
                 }
//=======================================================================================      
    switch(TFB)   {     case 1 : string TimeFrameStrB="Period_M1"; break;
                        case 5 : TimeFrameStrB="Period_M5"; break;
                       case 15 : TimeFrameStrB="Period_M15"; break;
                       case 30 : TimeFrameStrB="Period_M30"; break;
                       case 60 : TimeFrameStrB="Period_H1"; break;
                      case 240 : TimeFrameStrB="Period_H4"; break;
                     case 1440 : TimeFrameStrB="Period_D1"; break;
                    case 10080 : TimeFrameStrB="Period_W1"; break;
                    case 43200 : TimeFrameStrB="Period_MN1"; break;
                       default : TimeFrameStrB="Current Timeframe";
                   SetStepTFB_Up();
                  }
//=======================================================================================     
    switch(TFC)    {    case 1 : string TimeFrameStrC="Period_M1"; break;
                        case 5 : TimeFrameStrC="Period_M5"; break;
                       case 15 : TimeFrameStrC="Period_M15"; break;
                       case 30 : TimeFrameStrC="Period_M30"; break;
                       case 60 : TimeFrameStrC="Period_H1"; break;
                      case 240 : TimeFrameStrC="Period_H4"; break;
                     case 1440 : TimeFrameStrC="Period_D1"; break;
                    case 10080 : TimeFrameStrC="Period_W1"; break;
                    case 43200 : TimeFrameStrC="Period_MN1"; break;
                       default : TimeFrameStrC="Current Timeframe";
                    SetStepTFC_Up();
                  }
//=======================================================================================     
    switch(TFD)    {    case 1 : string TimeFrameStrD="Period_M1"; break;
                        case 5 : TimeFrameStrD="Period_M5"; break;
                       case 15 : TimeFrameStrD="Period_M15"; break;
                       case 30 : TimeFrameStrD="Period_M30"; break;
                       case 60 : TimeFrameStrD="Period_H1"; break;
                      case 240 : TimeFrameStrD="Period_H4"; break;
                     case 1440 : TimeFrameStrD="Period_D1"; break;
                    case 10080 : TimeFrameStrD="Period_W1"; break;
                    case 43200 : TimeFrameStrD="Period_MN1"; break;
                       default : TimeFrameStrD="Current Timeframe";
                    SetStepTFD_Up();
                  }                  
//=======================================================================================  
         }
          return(0);
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int deinit()
  {     Refresh();
        return(0);
  }         
//+--------------------------------------------------------------------------------------+
int start()
  {  Refresh();
     datetime TimeArray[]; datetime TimeArray1[]; datetime TimeArray2[];datetime TimeArray3[];
  
     double TEPAm_main,TEPAm_sign;
     double TEPBm_main,TEPBm_sign;
     double TEPCm_main,TEPCm_sign;
     double TEPDm_main,TEPDm_sign;
     
     int TEPAL=0,   TEPBL=0,  TEPCL=0,  TEPDL=0 ;
   
     int i,limit,counted_bars=IndicatorCounted();
     int y=0,y1=0,y2=0,y3=0;
     
    ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TFA); 
    ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),TFB); 
    ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),TFC); 
    ArrayCopySeries(TimeArray3,MODE_TIME,Symbol(),TFD); 
 
   limit=Bars-counted_bars;
//==============================================================================================       
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     SetIndexDrawBegin(4,Bars-CountBars);
     SetIndexDrawBegin(5,Bars-CountBars);
     SetIndexDrawBegin(6,Bars-CountBars);
     SetIndexDrawBegin(7,Bars-CountBars);
// ------------------  laat laaste 2 kerse repaint(smooth)--------------------------------       
   //   if(counted_bars>0) limit++; else if (limit>100) limit=CountBars;  
   
//======================  CHANGE PERIOD   ===========================================================   
    switch(Period()) 
  { case 1:    TEPAL = MA_Per_1M;    TEPBL = MA_Per_5M;     TEPCL = MA_Per_15M;    TEPDL = MA_Per_30M  ; break;
    case 5:    TEPAL = MA_Per_5M;    TEPBL = MA_Per_15M;    TEPCL = MA_Per_30M;    TEPDL = MA_Per_60M  ; break;
    case 15:   TEPAL = MA_Per_15M;   TEPBL = MA_Per_30M;    TEPCL = MA_Per_60M;    TEPDL = MA_Per_60M  ; break;
    case 30:   TEPAL = MA_Per_30M;   TEPBL = MA_Per_60M;    TEPCL = MA_Per_60M;    TEPDL = MA_Per_60M  ; break;
    case 60:   TEPAL = MA_Per_60M;   TEPBL = MA_Per_60M;    TEPCL = MA_Per_60M;    TEPDL = MA_Per_60M  ; break;
    case 240:  TEPAL = MA_Per_60M;   TEPBL = MA_Per_60M;    TEPCL = MA_Per_60M;    TEPDL = MA_Per_60M  ; break;
    case 1440: TEPAL = MA_Per_60M;   TEPBL = MA_Per_60M;    TEPCL = MA_Per_60M;    TEPDL = MA_Per_60M  ; break;
    case 10080:TEPAL = MA_Per_60M;   TEPBL = MA_Per_60M;    TEPCL = MA_Per_60M;    TEPDL = MA_Per_60M  ; break;
    case 43200:TEPAL = MA_Per_60M;   TEPBL = MA_Per_60M;    TEPCL = MA_Per_60M;    TEPDL = MA_Per_60M  ; break;
  } 
//==============================================================================       
   
         {    string  ThisName = "TEV";
              string Text=ThisName;
              Text=Text+"(TF "+TFA+","+TFB+","+TFC+","+TFD+")";
              Text=Text+"(";
              Text=Text+"Per "+DoubleToStr(TEPAL,0);
              Text=Text+", "+DoubleToStr(TEPBL,0);
              Text=Text+" ,"+DoubleToStr(TEPCL,0);
              Text=Text+", "+DoubleToStr(TEPDL,0);
              Text=Text+", Ma "+DoubleToStr(MA_SiEmSmWe3,0);
              Text=Text+")";
              IndicatorShortName(Text); 
         }        
          
//=======================  HEADINGE  =============================================================  
   if(ObjectFind("HEAD_ZZZ_TEV")==1)  
    {    
     ObjectCreate("HEAD_ZZZ_TEV", OBJ_LABEL,WindowFind(Text), 0, 0);
     ObjectSetText("HEAD_ZZZ_TEV", "TREND_v6" , 8, "Tahoma Narrow", Gold);
     ObjectSet("HEAD_ZZZ_TEV", OBJPROP_CORNER, 1);
     ObjectSet("HEAD_ZZZ_TEV", OBJPROP_XDISTANCE, 20);
     ObjectSet("HEAD_ZZZ_TEV", OBJPROP_YDISTANCE, 5 ); 
   }   
//==============================================================================    
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y])   y++;  
      if (Time[i]<TimeArray1[y1]) y1++;  
      if (Time[i]<TimeArray2[y2]) y2++;  
      if (Time[i]<TimeArray3[y3]) y3++;   
        

//===================== TEP A ========================================================================
                       
         
            TEPAm_main  = iCustom(NULL,TFA,"TrendEnvelopes_v6",TEPAL,MA_SiEmSmWe3,0,y);
            TEPAm_sign  = iCustom(NULL,TFA,"TrendEnvelopes_v6",TEPAL,MA_SiEmSmWe3,1,y);              
  
 
         if ((TEPAm_main > TEPAm_sign)){ TEPAm_up = 1; TEPAm_dn = 0; }
         if ((TEPAm_main < TEPAm_sign)){ TEPAm_up = 0; TEPAm_dn = 1; }   
 

                      double totalUpA   = 0.0;   double totalDnA   = 0.0;   
      
             if  (( TEPAm_up ) ==  1)   totalUpA  =   4 ;
             if  (( TEPAm_dn ) ==  1)   totalDnA  =   4 ;
  
                     ExtMapBuffer1[i] = 0;     ExtMapBuffer2[i] = 0;    
     
      if ( totalUpA == 4 || totalDnA ==  4 ){  ExtMapBuffer1[i] = totalUpA;  ExtMapBuffer2[i] = totalDnA; }   
       
 
 //===================================B MIN============================================     
 
           TEPBm_main  = iCustom(NULL,TFB,"TrendEnvelopes_v6",TEPBL,MA_SiEmSmWe3,0,y1);
           TEPBm_sign  = iCustom(NULL,TFB,"TrendEnvelopes_v6",TEPBL,MA_SiEmSmWe3,1,y1);               
 
   
         if ((TEPBm_main > TEPBm_sign)){ TEPBm_up = 1; TEPBm_dn = 0; }
         if ((TEPBm_main < TEPBm_sign)){ TEPBm_up = 0; TEPBm_dn = 1; }       

                      double totalUpB   = 0.0;   double totalDnB   = 0.0;   
      
             if  (( TEPBm_up ) ==  1)   totalUpB  =   3 ;
             if  (( TEPBm_dn ) ==  1)   totalDnB  =   3 ;
  
                     ExtMapBuffer3[i] = 0;     ExtMapBuffer4[i] = 0;    
     
      if ( totalUpB == 3 || totalDnB ==  3 ){  ExtMapBuffer3[i] = totalUpB;  ExtMapBuffer4[i] = totalDnB; }
 
//======================================C MIN==========================================  
    
            TEPCm_main  = iCustom(NULL,TFC,"TrendEnvelopes_v6",TEPCL,MA_SiEmSmWe3,0,y2);
            TEPCm_sign  = iCustom(NULL,TFC,"TrendEnvelopes_v6",TEPCL,MA_SiEmSmWe3,1,y2);       
              
         if ((TEPCm_main > TEPCm_sign)){ TEPCm_up = 1; TEPCm_dn = 0; }
         if ((TEPCm_main < TEPCm_sign)){ TEPCm_up = 0; TEPCm_dn = 1; }     
  
                      double totalUpC   = 0.0;   double totalDnC   = 0.0;   
      
             if  (( TEPCm_up ) ==  1)   totalUpC  =   2 ;
             if  (( TEPCm_dn ) ==  1)   totalDnC  =   2 ;
  
                     ExtMapBuffer5[i] = 0;     ExtMapBuffer6[i] = 0;    
     
      if ( totalUpC == 2 || totalDnC ==  2 ){  ExtMapBuffer5[i] = totalUpC;  ExtMapBuffer6[i] = totalDnC; }
 
//=====================================D MIN===========================================  

            TEPDm_main  = iCustom(NULL,TFD,"TrendEnvelopes_v6",TEPDL,MA_SiEmSmWe3,0,y3);
            TEPDm_sign  = iCustom(NULL,TFD,"TrendEnvelopes_v6",TEPDL,MA_SiEmSmWe3,1,y3);  
    
         if ((TEPDm_main > TEPDm_sign)){ TEPDm_up = 1; TEPDm_dn = 0; }
         if ((TEPDm_main < TEPDm_sign)){ TEPDm_up = 0; TEPDm_dn = 1; }   
         

                      double totalUpD   = 0.0;   double totalDnD   = 0.0;   
      
             if  (( TEPDm_up ) ==  1)   totalUpD  =   1 ;
             if  (( TEPDm_dn ) ==  1)   totalDnD  =   1 ;
  
                     ExtMapBuffer7[i] = 0;     ExtMapBuffer8[i] = 0;    
     
      if ( totalUpD == 1 || totalDnD ==  1 ){  ExtMapBuffer7[i] = totalUpD;  ExtMapBuffer8[i] = totalDnD; }
      
      
 //=====================================================================================
      } 
        return(0);
     }
 //================================================================================== ++       
             void SetValuesA(int pA)  {  TFA = pA;        }                                   
        void SetStepTFA_Up()     {  switch (Period() )                
           {  case PERIOD_M1  :  SetValuesA(PERIOD_M1);  break;       
              case PERIOD_M5  :  SetValuesA(PERIOD_M5);  break;         
              case PERIOD_M15 :  SetValuesA(PERIOD_M15); break;     
              case PERIOD_M30 :  SetValuesA(PERIOD_M30); break;            
              case PERIOD_H1  :  SetValuesA(PERIOD_H1);  break;               
              case PERIOD_H4  :  SetValuesA(PERIOD_H4);  break;                
              case PERIOD_D1  :  SetValuesA(PERIOD_D1);  break;                
              case PERIOD_W1  :  SetValuesA(PERIOD_W1);  break;             
              case PERIOD_MN1 :  SetValuesA(PERIOD_MN1); break;                   
           } }    

//==============================step timeframe up TF1====================================  
       void SetValuesB(int pB) { TFB = pB;        }                                    
       void SetStepTFB_Up()   { switch (Period() )                
           { case PERIOD_M1  :  SetValuesB(PERIOD_M5);    break;       
             case PERIOD_M5  :  SetValuesB(PERIOD_M15);   break;         
             case PERIOD_M15 :  SetValuesB(PERIOD_M30);   break;     
             case PERIOD_M30 :  SetValuesB(PERIOD_H1);    break;            
             case PERIOD_H1  :  SetValuesB(PERIOD_H4);    break;               
             case PERIOD_H4  :  SetValuesB(PERIOD_D1);    break;                
             case PERIOD_D1  :  SetValuesB(PERIOD_W1);    break;                
             case PERIOD_W1  :  SetValuesB(PERIOD_MN1);   break;             
             case PERIOD_MN1 :  SetValuesB(PERIOD_MN1);   break;                   
          } }   
//============================== TF2 ===================================================     
       void SetValuesC(int pC) {  TFC = pC;         }                                    
       void SetStepTFC_Up()    {  switch (Period()  )                
          { case PERIOD_M1  :  SetValuesC(PERIOD_M15);  break;       
            case PERIOD_M5  :  SetValuesC(PERIOD_M30);  break;         
            case PERIOD_M15 :  SetValuesC(PERIOD_H1);   break;     
            case PERIOD_M30 :  SetValuesC(PERIOD_H4);   break;            
            case PERIOD_H1  :  SetValuesC(PERIOD_D1);   break;               
            case PERIOD_H4  :  SetValuesC(PERIOD_W1);   break;                
            case PERIOD_D1  :  SetValuesC(PERIOD_MN1);  break;                
            case PERIOD_W1  :  SetValuesC(PERIOD_MN1);  break;             
            case PERIOD_MN1 :  SetValuesC(PERIOD_MN1);  break;                   
         } }    
//=============================== TF3 ==================================================  
        void SetValuesD(int pD)  {  TFD = pD;        }                                   
        void SetStepTFD_Up()     {  switch (Period() )                
           {  case PERIOD_M1  :  SetValuesD(PERIOD_M30); break;       
              case PERIOD_M5  :  SetValuesD(PERIOD_H1);  break;         
              case PERIOD_M15 :  SetValuesD(PERIOD_H4);  break;     
              case PERIOD_M30 :  SetValuesD(PERIOD_D1);  break;            
              case PERIOD_H1  :  SetValuesD(PERIOD_W1);  break;               
              case PERIOD_H4  :  SetValuesD(PERIOD_MN1); break;                
              case PERIOD_D1  :  SetValuesD(PERIOD_MN1); break;                
              case PERIOD_W1  :  SetValuesD(PERIOD_MN1); break;             
              case PERIOD_MN1 :  SetValuesD(PERIOD_MN1); break;              
           } }    
 //================================================================================== 

void Refresh() 
   {         ObjectDelete("HEAD_ZZZ_TEV");     
      
   }
 
//------------------------------------------------------------------------------------+  
 

